=== Crayon Syntax Highlighter ===
Contributors: akarmenia
Donate link: https://www.paypal.com/cgi-bin/webscr?cmd=_donations&business=AW99EMEPQ4CFE&lc=AU&item_name=Crayon%20Syntax%20Highlighter%20Donation&item_number=crayon%2ddonate&currency_code=AUD&bn=PP%2dDonationsBF%3abtn_donate_SM%2egif%3aNonHosted
License: GPLv2 or later
Tags: syntax highlighter, syntax, highlighter, highlighting, crayon, code highlighter, bbpress
Requires at least: 3.0
Tested up to: 4.2.0
Stable tag: trunk

Syntax Highlighter supporting multiple languages, themes, fonts, highlighting from a URL, or post text.

== Description ==

A Syntax Highlighter built in PHP and jQuery that supports customizable languages and themes.
It can highlight from a URL, or Wordpress post text. Crayon makes it easy to manage Language files and define
custom language elements with regular expressions.
It also supports some neat features like:

* Integrated <a href="http://aramk.com/blog/2012/12/27/crayon-theme-editor/" target="_blank">Theme Editor!</a>
* <a href="http://aramk.com/blog/2012/03/25/crayon-tag-editor/" target="_blank">Tag Editor</a> in both Visual & HTML editors
* Toggled plain code
* Toggled line numbers
* Copy/paste code
* Open code in a new window (popup)
* Line wrapping
* Code expanding
* Minimizing
* bbPress 2 support
* <a href="http://aramk.com/blog/2012/09/26/converting-legacy-tags-to-pre/" target="_blank">Converting legacy code in blog posts/comments to &lt;pre&gt;</a>
* Remote request caching
* <a href="http://aramk.com/blog/2011/12/25/mixed-language-highlighting-in-crayon" target="_blank">Mixed Language Highlighting</a> in a single Crayon
* <a href="http://aramk.com/blog/2011/12/27/mini-tags-in-crayon/" target="_blank">Mini Tags</a> like [php][/php]
* <a href="http://aramk.com/blog/2012/03/07/inline-crayons/" target="_blank">Inline Tags</a> floating in sentences
* Crayons in comments
* &#96;Backquotes&#96; become &lt;code&gt;
* &lt;pre&gt; tag support, option to use <code>setting-value</code> in the class attribute
* Valid HTML 5 markup
* <a href="http://aramk.com/blog/2012/03/25/crayon-tag-editor/" target="_blank">Visual & HTML editor compatible</a>
* Mobile/touchscreen device detection
* Mouse event interaction (showing plain code on double click, toolbar on mouseover)
* Tab sizes
* Code title
* Toggled toolbar
* Retina buttons
* Striped lines
* Line marking (for important lines)
* <a href="http://aramk.com/blog/2012/09/02/line-ranges-in-crayon/" target="_blank">Line ranges (showing only parts of the code)</a>
* Starting line number (default is 1)
* File extension detection
* Live Preview in settings
* Dimensions, margins, alignment, font-size, line-height, float
* Extensive error logging

**Links**

* <a href="https://github.com/aramk/crayon-syntax-highlighter" target="_blank">Beta Releases</a>
* <a href="http://aramk.com/blog/2012/12/27/crayon-theme-editor/" target="_blank">Themes Demo</a>
* <a href="https://github.com/aramk/crayon-syntax-highlighter" target="_blank">GitHub Project</a>

**Contributions**

There are many ways you can help!

* Make a Theme and share
* Add support for your favourite <a href="http://aramk.com/blog/2011/09/23/crayon-language-file-specification/" target="_blank">Language</a>
* Write a post about your pastel experiences and share
* <a href="https://www.paypal.com/cgi-bin/webscr?cmd=_donations&business=AW99EMEPQ4CFE&lc=AU&item_name=Crayon%20Syntax%20Highlighter%20Donation&item_number=crayon%2ddonate&currency_code=AUD&bn=PP%2dDonationsBF%3abtn_donate_SM%2egif%3aNonHosted" target="_blank">Donate</a> to the project

**Supported Languages**

Languages are defined in language files using Regular Expressions to capture elements.
See the <a href="http://aramk.com/blog/2011/09/23/crayon-language-file-specification/" target="_blank">Crayon Language File Specification</a> to learn how to make your own.

* Default Language (one size fits all, highlights generic code)
* C1 (thanks to <a href="http://oparin.info/" target="_blank">Oparin Pavel</a>)
* ABAP
* ActionScript
* AmigaDOS (thanks to <a href="http://www.amigalog.com/" target="_blank">amigalog.com</a>)
* Apache
* AppleScript
* Arduino
* Assembly (x86)
* AutoIt
* C
* C#
* C++
* Clojure (thanks to <a href="https://github.com/mberndtgen" target="_blank"></a>)
* CoffeeScript (thanks to <a href="http://firn.jp/crayon-coffeescript" target="_blank">Dai Akatsuka</a>)
* CSS
* Delphi/Pascal (thanks to <a href="http://squashbrain.com/" target="_blank">Chris McClenny</a>)
* Delphi Web Script (thanks to <a href="http://www.smartmobilestudio.com" target="_blank">smartmobilestudio</a>)
* Diff (thanks to <a href="http://omniavin.co/post/262" target="_blank">omniavin</a>)
* Erlang (thanks to <a href="http://netroid.de/" target="_blank">Daniel</a>)
* Fabric Engine KL (thanks to <a href="https://github.com/AndrewHazelden" target="_blank">Andrew Hazelden</a>)
* Go
* Haskell
* HTML (XML/XHTML)
* INI
* Lisp
* Lua
* Maya MEL (thanks to <a href="https://github.com/AndrewHazelden" target="_blank">Andrew Hazelden</a>)
* Microsoft Registry (thanks to <a href="http://techexplored.com/2012/03/21/crayon-syntax-highlighter-reg-support/" target="_blank">techexplored.com</a>)
* MIVA Script
* Monkey (thanks to <a href="https://github.com/devolonter" target="_blank">Devolonter</a>)
* MS-DOS (thanks to <a href="http://www.amigalog.com/?p=334" target="_blank">http://www.amigalog.com/?p=334</a>)
* MySQL (thanks to <a href="http://assemblysys.com/" target="_blank">AssemblySys.com</a> and <a href="http://ansas-meyer.de/" target="_blank">ansas-meyer.de</a>)
* Java
* JavaScript
* Objective-C
* Papyrus
* Perl
* PHP
* PL/SQL
* PostgreSQL (thanks to <a href="http://bitorchestra.com/" target="_blank">Bitorchestra</a>)
* PowerShell
* Python
* R
* Ruby
* Rust (thanks to <a href="https://github.com/Stibbons" target="_blank">Stibbons</a>)
* Scheme (thanks to <a href="https://github.com/harry75369" target="_blank">Harry75369</a>)
* Shell (Unix)
* Swift (thanks to <a href="https://github.com/weyhan" target="_blank">weyhan</a>)
* Transact-SQL
* TeX
* Vim
* Visual Basic
* Visual Basic .NET (thanks to <a href="https://github.com/OomJan/crayon-lang-vbnet" target="_blank">Kevin Gardthausen</a>)
* YAML
* ZSH (thanks to <a href="https://github.com/Stibbons" target="_blank">Stibbons</a>)
* Others will be added when requested

**International Languages**

* Arabic (thanks to <a href="http://djennadhamza.eb2a.com/" target="_blank">Djennad Hamza</a>)
* Chinese Simplified (thanks to <a href="http://smerpup.com/" target="_blank">Dezhi Liu</a> & <a href="http://neverno.me/" target="_blank">Jash Yin</a>)
* Chinese Traditional (thanks to <a href="http://www.arefly.com/" target="_blank">Arefly</a>)
* Dutch (thanks to <a href="https://twitter.com/RobinRoelofsen" target="_blank">Robin Roelofsen</a> & <a href="https://twitter.com/#!/chilionsnoek" target="_blank">Chilion Snoek</a>)
* Finnish (thanks to <a href="https://github.com/vahalan" target="_blank">vahalan</a>)
* French (thanks to <a href="https://vhf.github.io" target="_blank">Victor Felder</a>)
* German (thanks to <a href="http://www.technologyblog.de/" target="_blank">Stephan Knau&szlig;</a>)
* Italian (thanks to <a href="http://www.federicobellucci.net/" target="_blank">Federico Bellucci</a>)
* Japanese (thanks to <a href="https://twitter.com/#!/west_323" target="_blank">@west_323</a>)
* Korean (thanks to <a href="https://github.com/dokenzy" target="_blank">dokenzy</a>)
* Lithuanian (thanks to Vincent G)
* Norwegian (thanks to <a href="http://www.jackalworks.com/blogg" target="_blank">Jackalworks</a>)
* Persian (thanks to MahdiY)
* Polish (thanks to <a href="https://github.com/toszcze" target="_blank">Bartosz Romanowski</a>, <a href="http://rob006.net/" target="_blank">Robert Korulczyk</a>)
* Portuguese (thanks to <a href="http://www.adonai.eti.br" target="_blank">Adonai S. Canez</a>)
* Russian (thanks to <a href="http://simplelib.com" target="_blank">Minimus</a> & <a href="http://atlocal.net/" target="_blank">Di_Skyer</a>)
* Slovak (thanks to Branco, <a href="https://twitter.com/#!/webhostgeeks" target="_blank">webhostgeeks/</a>)
* Slovenian (thanks to Jan Su&#353;nik, <a href="http://jodlajodla.si/" target="_blank">http://jodlajodla.si/</a>)
* Spanish (thanks to <a href="http://www.hbravo.com/" target="_blank">Hermann Bravo</a>)
* Tamil (thanks to <a href="http://kks21199.mrgoogleglass.com/" target="_blank">KKS21199</a>)
* Turkish (thanks to <a href="http://hakanertr.wordpress.com" target="_blank">Hakan</a>)
* Ukrainian (thanks to <a href="http://getvoip.com/blog" target="_blank">Michael Yunat</a>)
* Help from translators at improving/adding to this list greatly appreciated!

**Articles**

These are helpful for discovering new features.

* <a href="http://aramk.com/blog/2012/09/26/internal-post-management-crayon/" target="_blank">Internal Post Management in Crayon</a>
* <a href="http://aramk.com/blog/2012/09/26/converting-legacy-tags-to-pre/" target="_blank">Converting Legacy Tags to &lt;pre&gt;</a>
* <a href="http://aramk.com/blog/2012/09/08/crayon-with-bbpress/" target="_blank">Crayon with bbPress</a>
* <a href="http://aramk.com/blog/2012/09/02/line-ranges-in-crayon/" target="_blank">Line Ranges in Crayon</a>
* <a href="http://aramk.com/blog/2012/03/25/crayon-tag-editor/" target="_blank">Crayon Tag Editor</a>
* <a href="http://aramk.com/blog/2011/12/25/mixed-language-highlighting-in-crayon/" target="_blank">Mixed Language Highlighting in Crayon</a>
* <a href="http://aramk.com/blog/2011/12/27/mini-tags-in-crayon/" target="_blank">Mini Tags And Plain Tags In Crayon</a>
* <a href="http://aramk.com/blog/2012/03/07/inline-crayons/" target="_blank">Inline Tags</a>
* <a href="http://aramk.com/blog/2012/01/07/enqueuing-themes-and-fonts-in-crayon/" target="_blank">Enqueuing Themes and Fonts in Crayon</a>

**The Press**

A handful of articles from others written about Crayon, thanks guys!

* <a href="http://thedigitalhippies.com/digital/crayon-syntax-highlighter-plugin-theme-color-previews-demo/" target="_blank">Crayon Syntax Highlighter Plugin Theme Color Previews</a>
* <a href="http://www.webworkgarage.com/2013/07/using-crayon-syntax-highlighter-wordpress-plugin-to-post-code-snippets-on-your-blog/" target="_blank">Using Crayon Syntax Highlighter WordPress plugin to post code snippets on your blog</a>
* <a href="http://www.jjpro.net/2013/01/13/how-to-post-source-code-on-wordpress-2/" target="_blank">How to post source code on WordPress</a>
* <a href="http://www.emanueleferonato.com/2013/02/01/syntax-highlighter-switched-to-crayon/" target="_blank">Syntax highlighter switched to Crayon</a>
* <a href="http://www.wordpressthemeshq.net/5-best-syntax-highlighter-plugins-for-wordpress/" target="_blank">5 Best Syntax Highlighter Plugins for WordPress</a>
* <a href="http://amecylia.com/how-to-post-source-code-wordpress/" target="_blank">How To Post Source Code In Wordpress</a>
* <a href="http://icrunched.co/top-5-syntax-highlighter-wordpress-plugins/" target="_blank">Top 5 Syntax Highlighter WordPress Plugins</a>
* <a href="http://themesplugins.com/wordpress-Plugin/add-php-java-html-codes-posts-pages/" target="_blank">Crayon Syntax Highlighter � Plugin</a>
* <a href="http://bbpress.org/forums/topic/state-of-syntax-highlighter-support-in-bbpress-2/" target="_blank">State of syntax highlighter support in bbPress 2</a>
* <a href="http://www.techbrunch.fr/informations/plugin-wordpress-afficher-code-source/" target="_blank">The ultimate plugin for displaying code in WordPress (French)</a>
* <a href="http://www.trynull.com/2012/06/15/finally-wordpress-code-syntax-highlighting-that-works/" target="_blank">Finally!, A WordPress code syntax highlighting that works</a>
* <a href="http://selfpwnt.com/crayon-syntax-highlighter-and-its-studly-author/" target="_blank">Crayon Syntax Highlighter (and its studly author)</a>
* <a href="http://bit51.com/add-code-to-your-wordpress-posts-with-crayon-syntax-highlighter/" target="_blank">Add Code To Your WordPress Posts With Crayon Syntax Highlighter</a>
* <a href="http://www.wpsquare.com/syntax-highlighter-wordpress-plugins/" target="_blank">15 Best Syntax Highlighter WordPress Plugins</a>
* <a href="http://www.doitwithwp.com/displaying-code-in-wordpress-with-crayon-syntax-highlighter/" target="_blank">Displaying Code in WordPress with Crayon </a>
* <a href="http://blog.boxedpages.net/2012/03/15/abap-syntaxhighlighting-in-wordpress/" target="_blank">ABAP Syntax Highlighting in WordPress (German)</a>
* <a href="http://jstips.org/2012/04/23/crayon-syntax-highlighter-plugin/" target="_blank">Crayon Syntax Highlighter plugin</a>
* <a href="http://infodrug.ru/wordpress/kak-krasivo-vstavit-programmnyj-kod-v-wordpress-podsvetka-sintaksisa.html" target="_blank">Crayon Syntax Highlighter (Russian)</a>
* <a href="http://n-wp.ru/11513" target="_blank">Crayon Syntax Highlighter (also Russian)</a>
* <a href="http://kampungtoys.com/tag/crayon-syntax-highlighter/" target="_blank">How To Post Source Code</a>
* http://wp-best-practices.asdf573189.com/home/good-plugins/crayon-syntax-highlighter/
* http://www.wplover.com/2155/crayon-syntax-highlighter-plugin/
* http://www.htmlandphp.com/scripts/crayon-syntax-highlighter.html

**Donations**

Thanks to all those who donate to the project:

* Joe Sabate, Spain
* Kai Chen, Canada
* Chen Kaiyuan, China
* Kamarul Musa, Malaysia
* WallyWare, Inc., (https://pi-plates.com), USA
* Stéphane Rochat, (http://stephanerochat.ch), Switzerland
* Brennan Hale-Matthews, Canada
* Robert Giczewski, (http://www.lazydaemon.de/), Germany
* Hoke Media, (http://hoke.media/), USA
* Matthew Hood, Australia
* Brian Williams, USA
* Christian Martens, (http://insgesamt.net/), Germany
* Nilesh Govindrajan, (http://nileshgr.com/), India
* ZengChun Yang, China
* Alan Kaplan, (http://www.akaplan.com/blog), USA
* Christopher Yarbrough, (http://chrisyarbrough.com/), Germany
* Johann Weiher, (http://codequartett.de/), Germany
* Samuel Deering, Australia
* Billiard Greg, (http://billiardgreg.com/), USA
* Performance Simulations, (http://www.performancesimulations.com/), USA
* Lindsay Ross, (http://gravelrash.com), New Zealand
* Ruperto Coronado Muñoz, Mexico
* Stefan Onderka, (http://www.onderka.com), Germany
* Peter Kellner, (http://peterkellner.net), USA
* Open Hardware Design Group LLC, (http://opensourcehardwaregroup.com/), USA
* Helen McManus, (http://invisiblepixels.org/InvisibleWords/), Netherlands
* Thomas Fee, UK
* Julie Knowles, (http://knowlesfamily.com/), USA
* Peter Kriegel, (http://www.powershell-group.eu/), Germany
* Geo My WP, (http://geomywp.com), USA
* Raffael Vogler, Germany
* Erdal Cicek, Turkey
* Cloud-VPS, Poland
* Łukasz Bereza, Poland
* Laurence Scotford, UK
* Goretity Árpád László, (http://h2co3.org/blog), Hungary
* AdsProvider, USA
* Alicia Ramirez, (http://aliciaramirez.com/), Canada
* William Eisert, USA
* Inappix Development, (http://www.inappix.com/), Switzerland
* Stephen Sant, (http://thesantfamily.net/), UK
* David Rodriguez, (http://davidarodriguez.com/), USA
* Chris Moore, (http://moorecreativeideas.com/), USA
* Sohail Ahmed, (http://sohail.io.com/), USA
* Vanessa Garcia Espin, Spain
* Samad Malik, (http://samadmalik.com/), USA
* Wabbit Wanch Design, (http://www.wabbitwanch.com/), Canada
* Inopox Ltd, (http://inopox.com/), Cyprus
* Kho Minh Vi, (http://khominhvi.com/), UK
* Ivan Churakov, Russia
* Carla Macías González, Mexico
* Saulius Stonys, Lithuania
* Konstantin Sabel, Germany
* Luigi Massa, (http://bwlab.it/), Italy
* Anthony Steiner, (http://steinerd.com/), USA
* Alexander Harvey, (http://alexharvey.eu/), UK
* Minhazul Haque Shawon, Cyprus
* Raam Dev, (http://raamdev.com/), USA
* Scot Ranney, (http://scotsscripts.com/), USA
* Nico Hartung, (http://www.loggn.de/), Germany
* Joseph DeVenuta, USA
* Iván Prego García, Spain
* Johannes Luijten, (http://www.tweaking4all.com/, http://www.weethet.nl/), USA
* Jack Fruh, (http://basementjack.com/), USA
* Ross Barbieri, USA
* Will, Simple Phishing Toolkit (http://www.sptoolkit.com/), USA
* Tricia Aanderud, USA
* Tarek Sakr, (http://centrivision.com/), USA
* Jeff Benshetler, (http://branchpoint.net/), USA
* Oldrich Strachota, (http://www.strachota.net/), Czech Republic
* Dividend Ninja, (http://dividendninja.com/), Canada
* Chris Wiegman, (http://bit51.com/), USA
* Sven Meier, (http://www.codesix.net/), Germany
* Christy Wiggins, (http://www.jinxyisms.com/), USA
* eSnipe, Inc. (http://esnipe.com/), USA (again!)
* Aliseya Wright, (http://blog.xoxothemes.com/), USA
* Jeremy Worboys (http://complexcompulsions.com/), Australia
* Steve McGough, Spider Creations, LLC. (http://spidercreations.net/), USA
* eSnipe, Inc. (http://esnipe.com/), USA
* Gerald Drouillard (http://www.drouillard.biz/), USA
* Greg Pettit (http://blog.monkey-house.ca/), Canada
* Waimanu Solutions (http://daveblog.waimanu.web44.net/), USA
* Andrew McDonnell (http://blog.oldcomputerjunk.net/), Australia
* Perry Bonewell (http://pointatthemoon.co.uk/), United Kingdom
* Nick Weisser (http://www.openstream.ch/), Switzerland

== Installation ==

* Download the .zip of the plugin and extract the contents.
* Upload it to the Wordpress plugin directory and activate the plugin.
* Even easier, just go to <strong>Plugins > Add New</strong> and search for "Crayon".
* You can change settings and view help under <strong>Settings > Crayon</strong> in the Wordpress Admin.
* Make sure your theme either manually specifies jQuery, or uses the version shipped with Wordpress (recommended). You should NOT print out jQuery manually in the header as a script tag. <a href="http://wordpress.stackexchange.com/questions/1535/how-to-dequeue-a-script" target="_blank">Enqueueing it in Wordpresss</a> will prevent duplicate jQuery includes (also bad) and will allow other scripts to be placed AFTER jQuery in the head tag so they can use it. If you're uncertain, just let Wordpress handle it and remove any jQuery script tags you find in your theme's header.php.

== Frequently Asked Questions ==

Please see the <a href="https://github.com/aramk/crayon-syntax-highlighter" target="_blank">documentation</a> for all the details.

= Support =

Contact me at http://twitter.com/crayonsyntax or crayon.syntax@gmail.com.

== Screenshots ==

1. Classic theme.
2. Twilight theme.
3. Mixed Language Highlighting.
4. Tag Editor.
5. Theme Editor.

== Changelog ==

= 2.8.4 =
* ADDED:
    * CrayonWP::highlight() can return plain text instead of HTML. Used for AJAX requests to prevent
      XSS vulnerabilities.
* FIXED:
    * Support for tags (e.g. formatting) in the HTML for CrayonWP::highlight(). This affects
      bbPress. Only script tags and event attributes are stripped.

= 2.8.3 =
* FIXED:
    * header() use in CrayonWP::highlight()

= 2.8.2 =
* ADDED:
    * Plain white theme (thanks to http://vhbelvadi.com).

= 2.8.1 =
* ADDED:
    * Coy theme.
* FIXED:
    * Strip tags in output content for CrayonWP::highlight()

= 2.8.0 =
* ADDED:
    * Qtcreator theme.
    * Norwegian translation.
    * Amity theme.
    * Flat-UI theme.
    * Powershell theme.
    * Mm Dark Blue theme.
    * Prism Like theme.
    * Kaderu theme.
    * Kayote theme.
    * Xcode theme.
    * Source Code Pro font.
* FIXED:
    * Polish translation and other fixes (thanks to https://github.com/rob006).

= 2.7.1 =
* FIXED:
    * Bug causing sample code to give an error due to new restriction on loading local files.

= 2.7.0 =
* ADDED:
    * Onderka15 theme.
    * Obsidian Light theme.
* FIXED:
    * Prevented using is_admin() as a security query (thanks to <a href="https://research.g0blin.co.uk/" target="_blank">g0blin Research</a>).
    * Removed the ability to load files from the filesystem due to security vulnerabilities (thanks to <a href="http://kevinsubileau.fr" target="_blank">Kevin Subileau</a>). Ensure all URLs are publicly accessible.
    * Fixed a bug causing tags to be removed in some cases.

= 2.6.10 =
* ADDED:
    * Option to load crayon script in the footer to improve loading performance (thanks to <a href="https://github.com/sumhat" target="_blank">sumhat</a>).
    * X3Info theme
    * Papyrus language
* FIXED:
    * Support for nested multi-line strings in Swift language (thanks to <a href="https://github.com/nicolafiorillo" target="_blank">nicolafiorillo</a>).
    * CrayonFormatter::print_error() called non-statically (thanks to <a href="https://github.com/ksubileau" target="_blank">https://github.com/ksubileau</a>)
    * Admin CSS issue: https://github.com/aramk/crayon-syntax-highlighter/issues/250.
    * Table style incompatibility with WP 2015 theme.
    * Wrapped text now breaks per character.

= 2.6.9 =
* ADDED:
    * Setting to disable Crayon for posts older than a given date (thanks to <a href="https://github.com/weismannweb" target="_blank">weismannweb</a>).
    * Support for changing the text shown for "Add Code" and "Edit Code" buttons in the Tag Editor.
    * Orange Code theme.
    * Raygun theme.
    * Tamil language.
* FIXED:
    * Missing PHP keywords thanks to <a href="https://github.com/tst" target="_blank">tst</a>.
    * Error with undefined HTTP_USER_AGENT thanks to Enrique Cordero.
    * Removed misused error control operator.
    * HTTPS check for whether to use https://
    * Selection CSS style for plain code.
    * Reserved keywords in Ruby.

= 2.6.8 =
* ADDED:
    * OCaml language thanks to <a href="https://github.com/zhenjie" target="_blank">zhenjie</a>
    * Added Capacitacionti theme
* FIXED:
    * SVN issue with old versions of JS and CSS resources being deployed instead of the latest from the dev repo.

= 2.6.7 =
* ADDED:
    * Traditional Chinese translation (thanks to <a href="http://www.arefly.com/" target="_blank">Arefly</a>)
    * Converting tabs to spaces setting is now off by default. The original tab size setting is used with the tab-size CSS style instead to preserve tabs in the source.
    * "ignore:true" setting in the class of pre tags will prevent that code block from being parsed by Crayon.
    * Obsidian theme thanks to <a href="http://rakcheev.ru/" target="_blank">Rakcheev Artem</a>.
    * Visual Assist theme thanks to Brady Reuter.
* FIXED:
    * Styling for (?) buttons on settings page.

= 2.6.6 =
* ADDED:
    * Persian translation (thanks to MahdiY).
    * C1 language and themes (thanks to Oparin Pavel).
* FIXED:
    * Improved Chinese translation and Go language statements (thanks to <a href="https://github.com/sumhat" target="_blank">sumhat</a>)
    * Theme editor failing to load.
    * Updated to WP 4.0

= 2.6.5 =
* ADDED:
    * Shell-default theme.
* FIXED:
    * Added missing SVN files.

= 2.6.4 =
* ADDED:
    * Swift language (thanks to <a href="https://github.com/weyhan" target="_blank">weyhan</a>).
    * Light Abite theme.
    * Missing gettext for in settings page.
    * Finnish translation (thanks to <a href="https://github.com/vahalan" target="_blank">vahalan</a>).
* FIXED:
    * Issue causing other shortcode tags (e.g. captions) to be removed on post save.
    * Improved tag editor button style when active to use the default for TinyMCE.
    * Style missing for visual editor if switching from text mode after a refresh.
    * String matching fixes thanks to <a href="https://github.com/mcmanigle" target="_blank">mcmanigle</a>

= 2.6.3 =
* FIXED:
    * Removed commercial links from translations section following advice from WordPress.

= 2.6.2 =
* ADDED:
    * Ukrainian translation.
* FIXED:
    * Tag Editor compatibility with WordPress 3.9.1.
    * Reduced loading times by lazily loading Tag Editor content, which was parsing all languages to populate the dropdown.
    * Added more debug statements to log issues with loading resources and parsing languages.
    * Removed clear: both and float: none from crayon tag styles.

= 2.6.1 =
* ADDED:
    * Sublime-text theme.
    * PowerShell ISE Theme thanks to <a href="https://github.com/ITFiend" target="_blank">ITFiend</a>.
* FIXED:
    * C# improvements thanks to <a href="https://github.com/Meligy" target="_blank">Meligy</a>
    * Admin uses HTTPS for requests when available (thanks to <a href="https://github.com/taoeffect" target="_blank">taoeffect</a>)
    * Tag Editor button failing to function Firefox.
    * Shell language improvements thanks to <a href="https://github.com/mixProtocol" target="_blank">mixProtocol</a> and <a href="https://github.com/ITFiend" target="_blank">ITFiend</a>.

= 2.6.0 =
* ADDED:
    * Delphi Web Script language (thanks to <a href="http://www.smartmobilestudio.com" target="_blank">smartmobilestudio</a>).
    * Added Pspad theme.
    * Dark terminal theme (thanks to <a href="http://blog.naydenov.net/" target="_blank">http://blog.naydenov.net/</a>)
    * Support for user-defined languages in the wp-content/uploads/crayon-syntax-highlighter/langs folder which will remain after upgrades.
    * Korean translation.
* FIXED:
    * Dutch translation.
    * Compatibility with Wordpress 3.9:
    * Tag editor updated to comply with TinyMCE version 4.
    * Admin script failed to load since "wpdialgs-popup" script is no longer available.

= 2.5.0 =
* ADDED:
    * Delphi Web Script language (thanks to <a href="http://www.smartmobilestudio.com" target="_blank">smartmobilestudio</a>)
    * ZSH language
    * INI language
* FIXED:
    * Fixed a bug causing posts with only backquotes and no Crayon tags to be ignored.
    * wrap="off" is now set to wrap="soft" to adhere to W3C standards.
    * The copy button tooltip.
    * Retina button order in the sprite sheet.
    * Wrapping of code lines in some wordpress themes.
    * Wrapped line height was being overridden by CSS.
    * Settings page docs links.

= 2.4.3 =
* ADDED:
    * Slovenian language
    * Coda Special Board theme
    * Rust language
    * Utilities for converting files containing lines into arrays or regex
* FIXED:
    * Prevented Google translate from affecting the code.

= 2.4.2 =
* ADDED:
    * Cisco Router theme
    * PL/SQL language thanks to https://github.com/Xophmeister
    * Turnwall theme
    * Iris Vfx theme
    * bncplusplus theme
* FIXED:
    * Spans are no longer display:inline-block, which can cause spaces to disappear.
    * ObjC improvements thanks to https://github.com/springsup

= 2.4.1 =
* ADDED:
    * Merged two versions of MySQL from different authors into a single language folder
    * VB.net language
* FIXED:
    * Removed dependency on jQuery.browser.msie in popup script
    * Fixed Colorbox CSS conflicts
    * CSS improvements for Colorbox to prevent unusable controls
    * German translation improvements

= 2.4.0 =
* ADDED:
    * MySQL language
* FIXED:
    * Replaced Fancybox with Colorbox to comply with GPLv2

= 2.3.1 =
* ADDED:
    * New setting to remove &lt;code&gt; blocks surrounding the code, often not intended to be in the code itself
    * Scala language thanks to https://github.com/vkostyukov
* FIXED:
    * Most important documentation paths now point to github docs.

= 2.3.0 =
* ADDED:
    * Ada langauge from https://github.com/antiphasis/crayon-lang-ada
    * Monokai theme
    * CG Cookie theme
    * MATLAB language
    * Scala language
* FIXED:
    * Escaping quotes in strings
    * R language type literals
    * Arabic translation
    * Forced LTR for Crayon CSS, preventing the line numbers from appearing on the right
    * Added unhighlighted colour to theme editor and existing dark themes
    * New theme inputs not present in the loaded theme are added during save
    * Fixed a bug related to IIS 7.5 and uniqid(): https://github.com/aramk/crayon-syntax-highlighter/issues/97

= 2.2.1 =
* ADDED:
    * Mirc Dark theme
    * Feeldesign theme
    * IntelliJ theme
    * Arabic translation
* FIXED:
    * All language css classes are prefixed with "crayon-" to prevent conflicts
    * Terminal theme fix
    * Improved language readme
    * Lines containing a single zero appeared blank when highlighting was disabled
    * AppleScript regex (thanks to darricktheprogrammer)

= 2.2.0 =
* ADDED:
    * ASP language
    * Added Secrets of Rock theme
    * &lt;code&gt; tags can now be captured as either inline or block Crayons.
* FIXED:
    * Comments now pass through filters before being checked for Crayons.
    * JavaScript and CSS resources are minified into single files on the front-end to reduce HTTP requests.
    * Toolbar buttons use a sprite sheet, not individual images.
    * bbPress now allows posting Crayons for non-users

= 2.1.4 =
* ADDED:
    * Eclipse theme
    * Background colour for language added to Theme Editor
    * More extendable handling and santisation of settings
* FIXED:
    * Blog content was being treated as a single code block due to a change in the internal CrayonWP::highlight() method
    * Crayon post management is now refreshed when plugin is activated
    * Terminal theme improvement

= 2.1.3 =
* ADDED:
    * Line height can now be customised along with font size
    * AJAX method for highlighting Crayon using ajaxurl. See http://aramk.com/blog/2012/05/30/adding-crayon-to-posts-in-wordpress-programmatically/.
    * Ability to capture code tags as inline Crayons
    * Terminal theme
* FIXED:
    * Expanding code issues to do with position and dimensions
    * Toolbar font-size and line height improvements
    * Now settings which affect capturing trigger a refresh of crayon posts when modified
    * Added message about emailing in submit window of theme editor
    * Border is now drawn inside so right border won't clip from theme CSS
    * Comments were not detected to contain Crayons unless edited in wp-admin
    * Highlighting improvements for variables and entities

= 2.1.2 =
* ADDED:
    * R language
    * TinyMCE is automatically added to the comment box when the Tag Editor is enabled on the frontend
    * SQL Management Studio 2012 Theme
* FIXED:
    * bbPress Tag Editor button wasn't showing
    * Slashes are now added to post content before legacy tag conversion, since wp_update_post removes them
    * PowerShell improvements
    * Empty directory path on some pages
    * Expanding uses absolute positioning, so it will stay on top of other elements
    * When expanded the toolbar controls move left for easier toggling
    * CSS conflicts with wordpress themes causing line-height and font-size overrides to be ignored

= 2.1.1 =
* ADDED:
    * Arduino IDE theme thanks to LukaszWiecek (http://wordpress.org/support/topic/arduino-code-support)
    * User Fonts can be added to wp-content/crayon-syntax-highlighter/uploads/fonts/somefont.css
* FIXED:
    * Issues with resource management, preventing loading of user CSS themes and performing theme editor functions
    * C#, C++ id issues preventing them loading
    * Tag Editor duplicate loading issue prevented close dialog on HTML view
    * Arduino language updates thanks to LukaszWiecek (http://wordpress.org/support/topic/arduino-code-support)

= 2.1.0 =
* ADDED:
    * Arduino language
    * LESS language
    * Sass language
    * Lisp language
    * AmigaDOS language
    * Added CoffeeScript thanks to http://firn.jp/crayon-coffeescript
    * Line numbers right border in theme editor
    * New Themes: Familiar, Idle, Tomorrow, Tomorrow Night, Github, VS2012, VS2012 Black
    * Ability to minimize code
    * Translation to Slovak
* FIXED:
    * jQuery UI is no longer an external dependency; now using wpdialog(). Theme Editor updated to use wpdialog.
    * Inline tags. See: https://github.com/aramk/crayon-syntax-highlighter/issues/57
    * Tag Editor didn't work on front end
    * Improved legacy tag conversion functions by removing false positives arising from duplicate regex
    * Slightly faster conversion of legacy by delaying database writes until the end
    * &-quot; is also converted now in HTML
    * Position of color picker top is remembered
    * Minor bug in saving themes causing field name mapping to be ignored.
    * Added missing blank.gif in fancybox
    * MS DOS language fixes
    * Taken measures to prevent incorrect upload directory creating a folder in root.
    * Theme fixes. 'border' is now split automatically into separate CSS rules.
    * Monospaced font for Tag Editor
    * "Attempt to load Crayon's CSS and JavaScript only when needed" setting improvements
    * Logging improvements
    * Unchecked property: Notice: Undefined property: WP_Query::$post
    * Theme Editor PHP classes renamed to avoid conflicts
    * Log uses strval() instead of ob_start() to avoid conflicts with other plugins using ob_start() without ob_end_flush() or similar

= 2.0.2 =
* FIXED:
    * Converting tags failed to work since 2.0.0 - also fixed minor bugs leading to false positives for legacy tags.
    * Copy function was calling invalid function, preventing duplication from taking place.
    * Slashes are removed from server side input which was appearing from the change code dialog

= 2.0.1 =
* ADDED:
    * Ability to change sample code in settings
* FIXED:
    * Changes in ID definitions caused C++ and C# to fail loading.
    * Fixed issues with minified CSS not loading in popup window
    * Using wp_mkdir_p instead of mkdir for creating directories and such.
    * Admin resource dependencies

= 2.0.0 =
* ADDED:
    * Theme Editor allowing users to create and modify Crayon Themes!
    * Polish translation (thanks to <a href="https://github.com/toszcze" target="_blank">Bartosz Romanowski</a>)
    * Vim language
    * Solarized themes (thanks to <a href="https://github.com/Greduan" target="_blank">Greduan</a>)
    * Converting legacy tags now has an "encode" option. If selected, any legacy tag where the "decode" attribute is missing (neither true or false) has its code encoded and decode="true" specified.
* FIXED:
    * Removed fancybox_init.js and integrated into util.js, other minor improvements in loading Tag Editor
    * Improved expanding with shirt
    * Issues with expanding a single line, other minor issues.
    * Merged JS and PHP debugging toggle
    * Moved everything towards camelCase from underscores
    * Minor improvements to Objective-C
    * Numerous bug fixes and improvements!

= 1.17 =
* ADDED:
    * Selected text in the TinyMCE editor is now added into the code box of the Tag Editor
    * Retina buttons for the toolbar
    * Support for Wordpress 3.5
* FIXED:
    * Removed fancybox_init.js and integrated into util.js, other minor improvements in loading Tag Editor
    * Disabling popup now removes the JS resource
    * Refactored Tag Editor functions
    * Display Tag Editor settings on the frontend wasn't working
    * Removed contextual help and added more useful links, including online help
    * Checkboxes have labels instead of spans thanks to https://github.com/toszcze
    * Undefined php variable fix thanks to https://github.com/toszcze
    * Dimension fixes in js on hover
    * On iOS the fonts appeared larger for code than for line numbers.
    * Expanding code shrunk instead if the toolbar was visible
    * Updated Turkish

= 1.16 =
* ADDED:
    * Expanding code beyond the page border on mouseover - enable the setting under Settings > Crayon > Code.
    * Expanding the code is delayed in the same way using the toolbar delay setting.
    * French translation
    * Portuguese translation
* FIXED:
    * Carriage returns and new line characters were being treated differently and not being detected correctly. I'm using a new regex which detects both and also captures the line content: (?:^|(?<=\r\n|\n))[^\r\n]*
    * JS variable bugs when minifying with W3 Total Cache
    * CSS did not load in newly opened code window if minified
    * Saved comments did not capture Crayons until they were updated or the post list was refreshed in settings
    * Posts in settings are sorted now descending based on modified date
    * bbPress posts showed Crayons on the bottom of posts irrespective of their position in the post content.
    * Toggle plain code button appeared when plain code was disabled
    * Updated Turkish translation

= 1.15 =
* ADDED:
    * The settings page no longer searches through all posts looking for legacy tags until you hit a new "refresh" button. Refreshing will look through all posts for crayon tags, and also mark any that are legacy tags. The same process occurs on an individual basis when saving a post.
    * The settings page shows which posts contains legacy tags, and the buttons do not hide when showing the table.
    * Added theme information to the settings page
    * Improved version updating
    * Code in a new window loses size constraints
    * MS-DOS batch language (thanks to <a href="http://www.amigalog.com/?p=334" target="_blank">http://www.amigalog.com/?p=334</a>)
    * Minor improvements
* FIXED:
    * Fancybox issues have been fixed: http://aramk.com/blog/2012/11/28/initialising-fancybox-with-custom-objects/
    * max/min-height/width didn't work on Tag Editor
    * Width discrepancy before and after mouseover from 1px border
    * Before and after whitespace didn't display correctly
    * Code opened in a new window didn't display if the current wp theme css was included
    * IE 8 compatibility issues
    * Dropdown of languages in settings and Tag Editor are now sorted by name, not id
    * By default "Display the Tag Editor in any TinyMCE instances on the frontend" is disabled to reduce resources
    * Chinese translation updated

= 1.14 =
* All AJAX functions are now using the wp_ajax action and admin-ajax.php method defined here: http://codex.wordpress.org/AJAX_in_Plugins. This means Crayon no longer passes around the wp_load path and doesn't use it as a $_GET variable to load AJAX requests. The security vulnerability in 1.13 is no longer present and that code has been removed.
* font-size and line-height has been removed from the crayon style CSS and is specified using the settings screen - the custom font size is enabled at 12px. This allows you to disable the custom font size and allow your own CSS to take control of the sizing for you. With the custom size disabled the inherited size is applied, so the code will appear at the size of its parent element based on your wordpress theme.
* Update functionality has been improved so the CrayonWP update function is only called when an update is detected from a change in the version string, not every time you load the page! If using lower than 1.14 the custom font size setting is enabled for you, since this setting was disabled by default in previous versions.
* Fixed a bug preventing Tag Editor from showing on the front end (related to the AJAX fix)
* Moved global js variables to the init functions which are called on ready()
* Fancybox now uses "fancybox" as the script name and checks if another version is already queued
* Fixed a bug where post previews were not displaying any Crayon code
* Fixed an issue with code wrap not reverting when disabled
* Fixed a bug causing code wrap from distorting the style of the popup
* Added Erlang thanks to Daniel (<a href="http://netroid.de/" target="_blank">adostudio.it</a>)
* Fixed a bug where languages were parsed too late to pick up language modes
* Updated German translation.

= 1.13.1 =
* Fixed an bug with file paths on Windows causing false positives for the security checks needed to load AJAX requests; thanks to Andreas Giemza.
* Fixed a bug in list_posts.php, also thanks to Andreas.
* Added a more spaced classic theme, mostly for testing at the moment.

= 1.13 =
* Added line wrapping.
* Fixed a bug in converting tags.
* Fixed a bug preventing Tag Editor from opening in HTML editor.
* From now on, only the wp-admin will reveal your wordpress install directory.
* The plain code now wraps based on the toggle setting.
* Fixed a potential vulnerability when loading components through AJAX and a remote PHP file path is provided. Thanks to Charlie Eriksen via Secunia SVCRP.
* Spanish updated

= 1.12.1 =
* Fixed a bug with bbPress preventing posts from appearing.

= 1.12 =
* Added ability to convert all legacy Crayon tags in blog posts and comments to &lt;pre&gt; tags, retaining all attributes. These are the accepted standard for the Tag Editor and they're backwards compatible (if Crayon is off or you're using another highlighter).
* Added a button in the settings page to display the list of posts with Crayon tags
* Fixed a bug causing posts with Crayon tags only in the comments (not the post content) to be ignored.
* Added Go Language
* Added 4 new fonts suggested by <a href="http://andrealazzarotto.com/" target="_blank">Andrea Lazzarotto</a>
* Added Ado theme thanks to <a href="http://adostudio.it/" target="_blank">adostudio.it</a>
* Superfluous &lt;code&gt; tags wrapping around the code are removed
* Fixed encoding bug in rss feeds, now takes decode setting into account
* Fixed mixed highlighting + icon from showing all the time, only shows with mixed language code
* Fixed a bug introduced in 1.11 that caused the page to scroll up to the top on refresh
* Updated Spanish and Turkish translations

= 1.11 =
* Added bbPress support.
* Integrated Tag Editor with Fancybox, switched from the discontinued ThickBox, a fair amount of changes took place.
* Crayon should now appear pretty much anywhere TinyMCE does, and this can be tweaked to add more options later.
* Added setting to disable Tag Editor on front end, and/or disable its settings.
* Added the ability to specify <a href="http://aramk.com/blog/2012/09/02/line-ranges-in-crayon/" target="_blank">line ranges</a>
* Added Microsoft Registry language thanks to <a href="http://techexplored.com/2012/03/21/crayon-syntax-highlighter-reg-support/" target="_blank">techexplored.com</a>
* Added MIVA Script language
* Added Transact-SQL language
* Added option to add blank lines before and after the code
* Wrote a neat GeSHi language file scraper, makes it easier to scrape GeSHi files for grouped keywords and add them as Crayon languages
* Added improved Spanish translation (thanks to <a href="http://www.hbravo.com/" target="_blank">Hermann Bravo</a>)

= 1.10.1 =
* Added diff language thanks to <a href="http://omniavin.co/post/262" target="_blank">omniavin</a>
* Fixed CSS rule for plain-wrap
* Added CSS class and white background to popup window
* Removed noConflict() that was causing jQuery to fail on scripts that used $
* Fixed an issue in the German translation causing "%gt;" (should be "&") to be recognised as an argument in printf.
* The new method for using the wp_load.php path provided through a GET request from Crayon's js to its PHP should allow redefinitions WP directories in wp_config

= 1.10 =
* Added Dutch translation thanks to <a href="https://twitter.com/#!/chilionsnoek">@chilionsnoek</a>.
* Added Delphi/Pascal thanks to Chris McClenny (http://squashbrain.com/)
* Added AppleScript
* Language is automatically selected from the Tag Editor dropdown as you type a URL with an extension (e.g. typing "cs" would select "C#")
* Fixed a preventing language being detected from extension
* Fixed a bug causing crayon:false to be ignored in the class tag
* Cleaned up crayon's js so it's not possible to overwrite the jQuery instance
* Fixed bug causing repeats of Crayon due to broken tags from using Mini Tags
* Fixed isses with ignoring Mini Tags with $
* Added Italian translation thanks to Federico Bellucci (http://www.federicobellucci.net/)

= 1.9.12 =
* Fixed a bug caused by unescaped HTML elements in the plain code breaking the page markup, reverted to escaped and uses the new sanitisation method.

= 1.9.11 =
* Fixed an issue with IE 8 throwing JS errors for setStyleProperty
* Fixed yet another issue with \r\n causing incorrect span tags, refactored code.

= 1.9.10 =
* Another fix regarding the \r\n line breaks

= 1.9.9 =
* Fixed a bug caused when ensuring "\r\n" was present in 1.9.8. It was due to using '\r\n' instead of "\r\n".

= 1.9.8 =
* New API to access Crayon internals
* Added TeX thanks to http://blog.keyboardplaying.org/2012/06/08/syntax-highlighting-latex/
* Moved update method into settings page to improve efficiency a bit
* Fixed an issue causing HTML spaces to appear in plain code
* Made sure \r\n was present for all line breaks in plain code
* Fixed minor bugs in settings

= 1.9.7 =
* Fixed a crucial but hard to spot bug causing Crayon code to break by incorrectly handling ignored Crayons
* Added functions to generate Crayons when given Crayon tags in strings like the post content
* Added width:100%; so CSS float works
* Removed bit.ly links from this readme

= 1.9.6 =
* Fixed a bug causing wordpress wp_content path customisations to break the tag editor and live preview
* Fixed a bug with marked lines using ranges

= 1.9.5 =
* Fixed a bug that prevent Crayons from being captured internally, only affected on certain themes
* Fixed a bug causing backquotes being changed to code within Crayon code

= 1.9.4 =
* Added /util/external_use.php for an example of how to use Crayon in other PHP environments.
* Fixed issues with the excerpt, now Crayons are not stripped out by default, can be changed in Settings &gt; Misc.
* Fixed font-size issues that may conflict on some themes.
* Crayons in comments now have their HTML entities decoded by default, specify "decode:false" in the class attr or decode="false" as an attr if you don't want it to decode.
* Fixed a newline bug thanks to Eugene at http://iteye.ru/

= 1.9.3 =
* Added Perl
* Minor bugs fixed thanks to http://hahler.de
* Fixed bug in js detecting PCs as Macs
* Fixed IE bug preventing code from opening in a window
* Fixed bug causing comment &lt;p&gt; tags being removed

= 1.9.2 =
* Fixed an error preventing code containing HTML tags from being added using the Tag Editor in Visual mode
* Fixed CSS for Mixed Highlighting (+)
* Added a new theme thanks to http://blog.phiphou.com

= 1.9.1 =
* Added Assembly (x86)
* Standardised the toolbar buttons, now they use CSS spriting and have the same colour
* Changed Theme CSS background to avoid conflicts with themes that affect TD tags
* Fixed bug caused by discrepancies in how checkbox values were handled in Tag Editor
* Fixed a bug causing $root variable to change on some setups, preventing tag editor from loading

= 1.9.0 =
* This update is the biggest update yet - highly recommended for all users.
* Added a brand new Tag Editor in the Visual Editor toolbar! <strong>Greatly</strong> simplifies adding code to posts in the Visual Editor. You can also switch between Visual and HTML modes to verify your code before posting!
* Added ability to decode HTML entities, so now you can use &lt;, &gt; etc. in the Visual Editor. But if you need indentation etc, you'll want to use the HTML editor for posts with Crayons. You can also use decode="yes/no/true/false" to set this for an individual Crayon.
* Added ability to decode attributes, which is enabled by default to avoid seeing encoded strings in the title, and also to allow encoded angle/square brackets in the title that would otherwise clash with the Crayon tag brackets if left unencoded.
* Added ability to use the class attribute in &lt;pre&gt; tags for specifying settings like url, mark, lang, toolbar and all other valid settings like in a normal [crayon] tag. This will ensure your &lt;pre&gt; tags remain valid XHTML markup even with Crayon disabled.
* Added ability to specify hyphen-separated-values in the class attribute of a &lt;pre&gt; tag to make them look like actual class selectors. E.g. &lt;pre class="lang-objc toolbar-false"&gt;...&lt;/pre&gt;. The setting name is made up of letters and hyphens ONLY, the value is whatever is left between the last hyphen and the next whitespace character.
* Added Scheme language thanks to https://github.com/harry75369
* Added ABAP language with help from Christian Fein
* Added a new setting: crayon="false/no/0" as an attribute or crayon:false in the class tag of a &lt;pre&gt;. This will ignore the &lt;pre&gt; tag and not turn it into a Crayon for those rare cases you don't want to use the plugin.
* Improved the method of finding posts with Crayons - now it will search through all posts for Crayons and save the ids in the options db. When the_posts is called, it won't need to do any extra searching on page loading and will already know which post has Crayons. Like before, pages which might use page templates will turn off enqueuing of fonts and themes to ensure they are always printed.
* Overriden Language File elements are now put first in the CSS class name, so the extended element can override in a theme
* Prevented capturing Crayons in the admin
* Crayons now use HTML5 valid markup
* I'm still sticking to the wrap="off" for no-wrapping preformatted styling - CSS doesn't do the trick yet: http://stackoverflow.com/questions/657795/how-remove-wordwrap-from-textarea
* Improved ajax handling
* Cleaned up the settings screen
* Line numbers now use UID in id to avoid duplicates
* Crayon CSS updated to use inline styles and never use style tags in the body
* Simplified the toolbar buttons to suit the minimalistic design of the rest of Crayon. It'll look badass with an inset shadow in a future theme...
* Plain tags are now just &lt;pre&gt; tags and don't contain the inline code tag since they are block tags.
* Fixed a MAJOR bug preventing previously captured Crayons from being applied to post content!
* Fixed a bug causing case insensitive Boolean settings to fail at times
* Fixed a bug causing a [crayon ... /] tags to be recognised as [c ... /] tags (added a \b)
* Fixed a bug preventing highlight="false" from working
* Fixed a bug preventing mouse events for showing plain code when toolbar is always hidden
* Fixed a bug preventing smart enqueuing from detecting if a Crayon was present before enqueuing resources.
* Fixed a bug causing inline tags to be surround in &lt;p&gt; tags
* Fixed a bug causing toolbar=1 to be regarded as toolbar=false from legacy settings
* Fixed a bug causing content to be specified but not formatted for URLs with no code given
* Fixed removing $ in font of ignored crayons like $&lt;pre...
* Fixed js .style bugs in < IE 9
* Cleaned up code for specifying attributes, NULL attributes are not passed as empty strings anymore.
* The log looks cleaner now
* Now crayons are replaced with [crayon-id/] in posts before being replaced with the actual Crayon
* If js ever fails to load, it won't affect styling, just functionality
* Added ability to use closed Mini Tags like [php ... \] when you're just giving a URL
* Added lenient spaces for closed tags
* Fixed element content text in XHTML to avoid capturing "" as strings
* Added Lithuanian translation thanks to <a href="http://www.host1free.com" target="_blank">Vincent G</a>

= 1.8.3 =
* Added inline support for Crayons using the inline="true" attribute or even cooler with {php}...{/php} style tags.
* `backquotes` become &lt;code&gt;
* Added support for Crayons in comments!
* Added Apache
* Fixed a bug causing irregular formatting of Crayons by increasing the priority of the_content filter, thanks to http://joshmountain.com/
* Added sample code for missing languages in Live Preview

= 1.8.2 =
* Added AutoIt and PowerShell
* Fixed a bug causing single line comments on the last line without carriage return to be ignored.
* Fixed bug causing crayon.js to fail when show-plain-default was enabled thanks to http://www.stuarticus.com/

= 1.8.1 =
* Added Lua
* Added YAML
* Added different highlighting for preprocessor in C, C++, C# and Obj-C. Any other lang can use it as well.
* Improved Russian translation thanks to Di_Skyer (http://atlocal.net/)
* Added new "Neon" theme thanks to Di_Skyer (http://atlocal.net/)
* Added ability to log debug messages if CRAYON_DEBUG is TRUE in global.php
* Added ALLOW_MIXED = YES/NO option in language files to disable ability to have mixed language highlighting

= 1.8.0 =
* Added PostgreSQL thanks to Emiliano Leporati and Alessandro Venezia from http://bitorchestra.com/
* Added ActionScript
* Thanks to Thomas Tan for finding and fixing IE6 compatibility bugs in crayon.js!
* Improved Objective-C, XHTML and default language
* ?alt: tag now supports spaces in language files, treats then as \s+
* Added support for single quotes in CSS and JS

= 1.7.30 =
* Added Inventor iLogic as a language
* Added cellspacing and cellpadding back into table due to spacing issue after trying to conform to W3C standards...
* Improved default language constants
* Added missing language samples for live preview (ruby, monkey and ilogic)
* More prominent "show language" button

= 1.7.29 =
* Thanks to @west_323 for updating the Japanese translation

= 1.7.28 =
* Fixed a bug prevent attributes from being detected since 1.7.24
* Added Turkish languge thanks to Hakan (http://kazancexpert.com)

= 1.7.27 =
* Recommended update for everyone. This fixes a bug in 1.7.25 where Mixed Highlighting would fail inside an html tag
* Greatly simplified the mixed highlighting method, more robust
* Made it impossible to nest delimiters, which mimics the behaviour in supported languages.

= 1.7.26 =
* Added translations to the tooltips and copy notification in the toolbar

= 1.7.25 =
* German translation improved by Stephan Knau&szlig;;
* Added missing translations in other languages and fixed bug preventing dropdowns from being translated
* Added translators to the about page
* Oh, added <code>&lt;html&gt;...&lt;/html&gt;</code> tag into the delimiters
* But of course, if you wanted say HTML with PHP, then you'd set the language to HTML and use <code>&lt;?php ... ?&gt;</code> tag when you needed them

= 1.7.24 =
* Added support for Ruby(on Rails)?
* Added support for Ruby file extensions like rb, rbx
* Added "rb" alias for [rb][/rb] Mini Tags
* Added RHTML delimiters like %lt;% and %%gt;
* Added a bottom margin to the Plain Tag
* Added support for quotes in the title attribute
* You still need to use <code>" some 'title'"</code> or <code>' some "title" '</code> properly, not "' or '" ;)

= 1.7.23 =
* Remove 'theme-font' and replaced default as 'Monaco'.
* Remove @import for fonts and replace with CSS tags. This should fix any 404 issues.
* Now all fonts reside in /fonts with font-face fonts having a separate directory by their name to store the font vectors etc

= 1.7.22 =
* Fixed dimension and redraw issues on scrollbars

= 1.7.21 =
* Fixed a bug that relied on register_activation_hook to update the database on auto update

= 1.7.20 =
* "Always display scrollbars" now a checkbox

= 1.7.19 =
* Fixed issue with Crayons failing to load on pages with templates containing The Loop. http://aramk.com/blog/2012/01/23/failing-to-load-crayons-on-pages/
* Objective-C operators improved

= 1.7.18 =
* Fixed issue with extra &lt;br/&gt; and &lt;p&gt; tags before and after Crayons

= 1.7.17 =
* Added a setting to use just the main WP query or to use the_posts wherever it is used (default now).
* Improved XHTML

= 1.7.16 =
* Running out of revision numbers!
* Fixed a bug causing default-theme from loading as a font
* Fixed an issue where the js used to remove inline styles before opening in another window was missing the /g regex modifier
* Cleaned up loading and event handling in crayon.js
* Fixed a bug causing code popup to fail
* Improved CSS language
* Improved JS language by adding regex syntax, yay!
* Fixed issues with resizing Crayon and dimensions
* Added support for custom excerpts

= 1.7.15 =
* Fixed a bug prevented fonts and themes with spaces from being enqueued. Thanks to Fredrik Nygren.
* Improved handling of id's and names of resources.

= 1.7.14 =
* Fixed a bug that could potentially cause a PHP warning when reading the log when not permitted to do so.

= 1.7.13 =
* Fixed a bug causing my settings and donate links to be appended to all plugins in the list. Thanks to Ben.

= 1.7.12 =
* Added Russian translation thanks to minimus (http://simplelib.com)
* Added Consolas Font

= 1.7.11 =
* Added the option of either enqueuing themes and fonts (efficient) or printing them before the Crayon each time when enqueuing fails
* Thanks to http://www.adostudio.it/ for finding the bugs
* Improved theme and font handling
* Improved theme detection and Crayon capturing

= 1.7.10 =
* Fixed a visual artifact of loading that caused the plain code to be partially visible

= 1.7.9 =
* Added Monkey language thanks to https://github.com/devolonter/

= 1.7.8 =
* Fixed a JavaScript bug in admin preventing language list loading
* Fixed an issue causing plain code to load invisible the first time if set to default view
* Added translations for 1.7.7 features

= 1.7.7 =
* Added plain code toggling and ability to set plain code as default view
* Minor improvements to Objective-C
* Fixed some JavaScript bugs in the admin preview
* Fixed copy/paste key combinations. Thanks to http://wordpress.org/support/profile/nickelfault.

= 1.7.6 =
* Added highlight support for catching multiple exceptions in Java

= 1.7.5 =
* Removed jQuery.noConflict() from crayon.js. This must have been causing some trouble if anything used $.

= 1.7.4 =
* Added namespacing to crayon.js to prevent conflicts

= 1.7.3 =
* Added Mini Tags and Plain Tags into Crayon. http://aramk.com/blog/2011/12/27/mini-tags-in-crayon/
* Fixed a bug causing RSS feeds to contain malformed HTML of Crayons, now it shows plain code with correct indentations. Thanks to Артём.
* Updated help in Settings and https://github.com/aramk/crayon-syntax-highlighter

= 1.7.2 =
* Fixed a bug that prevented foreign languages from being initialised and used. Thanks to @west_323 for finding it.

= 1.7.1 =
* Renamed Japanese GNU language code from ja_JP to ja.

= 1.7.0 =
* Added the ability to highlight multiple languages in a single Crayon! http://aramk.com/blog/2011/12/25/mixed-language-highlighting-in-crayon/
* A bunch of language improvements, a few CSS improvements, etc.

= 1.6.6 =
* Fixed a bug causing international Unicode characters being garbled in the title (thanks to simplelib.com!)
* Fixed a bug that prevented strings from being highlighted

= 1.6.5 =
* Fixed a bug causing international Unicode characters being garbled

= 1.6.4 =
* Added user submitted Japanese language support. Thanks to @west_323!
* &lt;pre&gt;&lt;/pre&gt; tags are now captured as Crayons. This can be turned off in Settings > Crayon > Code.
* You can remove prevent capturing individual &lt;pre&gt; tags the same way as Crayons: $&lt;pre&gt; ... &lt;/pre&gt;
* This method of preventing the &lt;pre&gt; tag should be used if your code contains &lt;pre&gt; tags (nested &lt;pre&gt; tags) - otherwise it will cause conflicts.
* Keep in mind that &lt;pre&gt; tags should not be editted in Visual Mode. Crayon will display all code as it appears in the HTML view of the post editor, where you can make code changes and use the tab key etc. If you want to use the Visual editor reguarly and are running into problems, consider loading the code form a file using the 'url' attribute.
* I have removed the ability to have spacing between the starting and ending square brackets, so [crayon...] is valid but [ crayon ... ] is not.
The same applies to &lt;pre&gt; tags (not &lt; pre &gt;). The reason is to improve performance on posts without Crayons by using strpos and not regex functions like preg_match, and also it's better formed.
* Fixed a bug causing Plain Code to display characters as encoded HTML entities
* Removed jQuery 1.7 from /js folder. Now uses the version provided by WP.

= 1.6.3 =
* For those still having issues with CSS and JavaScript not laoding, I have added a new setting in Misc. that will allow you to either attempt to load these resources when needed if you have no issues with your theme or to force them to load on each page.
* Please see: http://aramk.com/blog/2011/12/12/loading-css-and-javascript-only-when-required-in-a-wordpress-plugin/

= 1.6.2 =
* Added ability to use and define language aliases. eg. XML -> XHTML, cpp -> c++, py -> python

= 1.6.1 =
* Avoided using $wp_query, $posts instead
* Updated contextual help to be compliant with WP 3.3

= 1.6.0 =
* Added internationalisation with 4 new languages: German, Spanish, French and Italian
* These were translated using Google Translate, so if you speak these languages and would like to improve them,
it's actually quite easy to edit - just contact me via email :)
* More languages will be added as they are demanded

= 1.5.4 =
* Recommended update for everyone
* Fixed a bug that caused the default theme not to load if was anything but "classic" - Thanks to Ralph!

= 1.5.3 =
* Fixed issue with incorrectly specified theme causing crash
* Email Developer improved

= 1.5.2 =
* Proper enquing of themes via wordpress, should cause no more issues with any themes
* Cached images for toolbar items, no delay on mouseover
* Fixed a minor regex bug in js preventing styles from being removed when in popup

= 1.5.1 =
* Fixed plain code toggle button update

= 1.5.0 =
* Added ability to cache remote code requests for a set period of time to reduce server load. See Settings > Crayon > Misc. You can clear the cache at any time in settings. Set the cache clearing interval to "Immediately" to prevent caching.
* Fixed a bug preventing dropdown settings from being set correctly
* Fixed AJAX settings bug
* Fixed CSS syntax bug for fonts
* Improved code popup, strips style atts
* Added preview code for shell, renamed to 'Shell'
* Code popup window now shows either highlighted or plain code, depending on which is currently visible

= 1.4.4 =
* Revised CSS style printing
* Fixed bugs with the "open in new window" and copy/paste actions
* Upgraded jQuery to 1.7

= 1.4.3 =
* Fixed a bug that caused the help info to remain visible after settings submit

= 1.4.2 =
* Huge overhaul of Crayon detection and highlighting
* IDs are now added to Crayons before detection
* No more identification issues possible
* Highlighting grabs the ID and uses it in JS
* Only detects Crayons in visible posts, performance improved
* This fixes issues with <!--nextpage-->

= 1.4.1 =
* Fixed Preview in settings, wasn't loading code from different languages
* Fixed code toggle button updating for copy/paste
* Added some keywords to c++, changed sample code

= 1.4.0 =
* Added all other global settings for easy overriding: http://aramk.com/blog/2011/10/29/crayon-settings/
* Fixed issues with variables and entites in language regex
* Added Epicgeeks theme made by Joe Newing of epicgeeks.net
* Help updated
* Fixed notice on missing jQuery string in settings
* Reduced number of setting reads
* Setting name cleanup
* Added a donate button, would appreciate any support offered and I hope you find Crayon useful
* String to boolean in util fixed

= 1.3.5 =
* Removed some leftover code from popupWindow

= 1.3.4 =
* Added the ability to open the Crayon in an external window for Mobile devices, originally thought it wouldn't show popup

= 1.3.3 =
* Added the ability to open the Crayon in an external window

= 1.3.2 =
* Added missing copy icon

= 1.3.1 =
* This fixes an issue that was not completely fixed in 1.3.0:
* Removed the lookbehind condition for escaping $ and \ for backreference bug

= 1.3.0 =
* Recommended upgrade for everyone.
* Major bug fix thanks to twitter.com/42dotno and twitter.com/eriras
* Fixed a bug causing attributes using single quotes to be undetected
* Fixed a bug causing code with dollar signs followed by numbers to be detected as backreferences and replace itself!
* Fixed a bug causing formatting to be totally disregarded.
* Fixed the <!--more--> tag in post_content and the_excerpt by placing crayon detection after all other formatting has taken place
* Added copy and paste, didn't use flash, selects text and asks user to copy (more elegant until they sort out clipboard access)
* Added shell script to languages - use with lang='sh'
* Removed certain usage of heredocs and replaced with string concatenation
* Added 'then' to default statements
* Cleaned up processing of post_queue used for Crayon detection and the_excerpt
* Added focus to plain text to allow easier copy-paste

= 1.2.3 =
* Prevented Crayons from appearing as plain text in excerpts
http://wordpress.org/support/topic/plugin-crayon-syntax-highlighter-this-plugin-breaks-the-tag

= 1.2.2 =
* Fixed the regex for detecting python docstrings. It's a killer, but it works!
(?:(?<!\\)""".*?(?<!\\)""")|(?:(?<!\\)'''.*?(?<!\\)''')|((?<!\\)".*?(?<!\\)")|((?<!\\)'.*?(?<!\\)')

= 1.2.1 =
* Added the feature to specify the starting line number both globally in settings and also using the attribute:
** [crayon start-line="1234"]fun code[/crayon]
* Thanks for the suggestion from travishill:
** http://wordpress.org/support/topic/plugin-crayon-syntax-highlighter-add-the-ability-to-specify-starting-line-number?replies=2#post-2389518

= 1.2.0 =
* Recommended upgrade for everyone.
* Fixed crucial filesystem errors for Windows regarding filepaths and resource loading
* Said Windows bug was causing Live Preview to fail, nevermore.
* Fixed loading based on URL structure that caused wp_remote errors and local paths not being recognised
* Removed redundant dependency on filesystem path slashes
* PHP now fades surrounding HTML

= 1.1.1 =
* Plugin version information is updated automatically

= 1.1.0 =
* Recommended upgrade for everyone running 1.0.3.
* Fixes a bug that causes code become unhighlighted
* Attribute names can be given in any case in shortcodes
* Fixes settings bug regarding copy constructor for locked settings
* Minor bug fixes and cleanups

= 1.0.3 =
* Added highlight="false" attribute to temporarily disable highlighting.
* Fixed default color of font for twilight font.

= 1.0.2 =
* Minor bug fixes.

= 1.0.1 =
* Fixed a bug that caused Themes not to load for some Crayons due to Wordpress content formatting.

= 1.0.0 =
* Initial Release. Huzzah!

== Upgrade Notice ==

Make sure to upgrade to the latest release when possible to ensure you avoid bugs others have found and enjoy new features.
